﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace СУБД_Швейная_фабрика
{
    public partial class FormAddOrder : Form
    {
        public FormAddOrder()
        {
            InitializeComponent();
        }
        public string IdZakazchik = "";  
        string IdCloth = "", IdFur = "";

        public struct Clothes
        {
            public string ID_Cloth, Name, Color, Width, Length, Comment;
            public Image Photo;
        }
        List<Clothes> LstTkani = new List<Clothes>();

        void GetClothesFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.SvFabricConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from Clothess where Length > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Clothes Cl = new Clothes();
                Cl.ID_Cloth = Data["ID_Cloth"].ToString();
                Cl.Name = Data["Name"].ToString();
                Cl.Color = Data["ID_Color"].ToString();
                Cl.Length = Data["Length"].ToString();
                Cl.Width = Data["Width"].ToString();
                Cl.Comment = Data["Comment"].ToString();
                try
                {
                    byte[] PhotoByte = (byte[])Data["Photo"];
                    ImageConverter ImConverter = new ImageConverter();
                    Cl.Photo = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    Cl.Photo = Properties.Resources.tmp;
                }
                LstTkani.Add(Cl);  
            }
            con.Close();
        }
        void FillClothes()
        {
            LVTkani.Items.Clear();
            foreach (Clothes Tk in LstTkani)
            {
                ListViewItem LV = new ListViewItem(Tk.Name);           
                LVTkani.Items.Add(LV);  
            }
        }
        public struct Furnitura
        {
            public string IdFur, NameFur, CountFur;
            public Image PhotoFur;
        }

        List<Furnitura> LstFurnitura = new List<Furnitura>();

        private void izdelieBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.izdelieBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.svFabricDataSet);

        }
        void GetFurnituraFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.SvFabricConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from Furnitures where Count_Fur > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Furnitura Fr = new Furnitura();
                Fr.IdFur = Data["ID_Fur"].ToString();
                Fr.NameFur = Data["Name_Fur"].ToString();
                Fr.CountFur = Data["Count_Fur"].ToString();
                try
                {
                    byte[] PhotoByte = (byte[])Data["Photo"];
                    ImageConverter ImConverter = new ImageConverter();
                    Fr.PhotoFur = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    Fr.PhotoFur = Properties.Resources.tmp;
                }
                LstFurnitura.Add(Fr);  
            }
            con.Close();
        }
        void FillLVFurnitura()
        {
            LVFurnitura.Items.Clear();
            foreach (Furnitura Fr in LstFurnitura)
            {
                ListViewItem LV = new ListViewItem(Fr.NameFur);
                LVFurnitura.Items.Add(LV);  
            }
        }
        int CutTkan(int WidthTkan, int WidthIzd, int LengthIzd, int CountIzd)
        {
            int IzdInRow1 = WidthTkan / WidthIzd;
            int Row1 = CountIzd / IzdInRow1;
            if (IzdInRow1 * Row1 < CountIzd)
                Row1++;
            int CutTkan1 = LengthIzd * Row1;
            int IzdInRow2 = WidthTkan / LengthIzd;
            int Row2 = CountIzd / IzdInRow2;
            if (IzdInRow2 * Row2 < CountIzd)
                Row2++;
            int CutTkan2 = WidthIzd * Row2;
            return Math.Min(CutTkan1, CutTkan2);
        }

        private void LVTkani_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVTkani.SelectedItems.Count > 0)  // есть выделенные элементы
            {
                int num = LVTkani.SelectedIndices[0];  // номер выделенного элемента
                NametkanTextBox.Text = LstTkani[num].Name;
                ColorTextBox.Text = LstTkani[num].Color;
                WidthTextBox.Text = LstTkani[num].Width;
                LengthTextBox.Text = LstTkani[num].Length;
                DescriptionTextBox.Text = LstTkani[num].Comment;
                IdCloth = LstTkani[num].ID_Cloth;
            }
            else  // нет выделенных элементов
            {
                NametkanTextBox.Text = "";
                ColorTextBox.Text = "";
                WidthTextBox.Text = "";
                LengthTextBox.Text = "";
                DescriptionTextBox.Text = "";
                IdCloth = "";
            }
        }

        private void LVFurnitura_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVFurnitura.SelectedItems.Count > 0)  // есть выделенные элементы
            {
                int num = LVFurnitura.SelectedIndices[0];  // номер выделенного элемента
                TbxNameFur.Text = LstFurnitura[num].NameFur;
                TbxCountFurSklad.Text = LstFurnitura[num].CountFur;
                IdFur = LstFurnitura[num].IdFur;
            }
            else  // нет выделенных элементов
            {
                TbxNameFur.Text = "";
                TbxCountFurSklad.Text = "";
                IdFur = "";
            }
        }

        private void BtnOK_Click(object sender, EventArgs e)
        {
            //int a = CutTkan(430, 150, 200, 4);
            //this.Text = a.ToString();
            //return;

            int NewCountFur = int.Parse(TbxCountFurSklad.Text) -
                int.Parse(TbxCountFur.Text) * int.Parse(TbxCountIzd.Text);
            SqlConnection con = new SqlConnection(Properties.Settings.Default.SvFabricConnectionString);
            con.Open();
            string t1 = string.Format(@"update Furnitures
set Count_Fur = {0}
where ID_Fur = {1}", NewCountFur, IdFur);
            SqlCommand query = new SqlCommand(t1, con);
            query.ExecuteNonQuery();
            con.Close();

            int WidthTkan = int.Parse(WidthTextBox.Text); // ширина ткани
            // ширина изделия
            int WidthIzd = int.Parse(DgvIzd.CurrentRow.Cells[2].Value.ToString());
            // длина изделия
            int LengthIzd = int.Parse(DgvIzd.CurrentRow.Cells[1].Value.ToString());
            int CountIzd = int.Parse(TbxCountIzd.Text); // кол-во изделий
            // отрезать от рулона ткани кусок нужной длины
            int NewLengthTkan = int.Parse(LengthTextBox.Text) -
                CutTkan(WidthTkan, WidthIzd, LengthIzd, CountIzd);

            // обновить таблицу Ткани (для выделенной ткани сохранить новую длину NewLengthTkan)

            // код менеджера для обработки нового заказа
            // нужно заменить на код наименее загруженного менеджера
            int IdManager = 2;

            try
            {
                con.Open();
                // SQL-запрос для добавления нового заказа
                string t = "insert into Orders (ID_Izdelie, ID_Zakazchik, ID_Manager, ID_Cloth, ID_Fur, Count_Fur, Count_zd) " +
                    $"values ({LblIdIzd.Text}, {IdZakazchik}, {IdManager}, {IdCloth}, {IdFur}, {TbxCountFur.Text}, {TbxCountIzd.Text})";
                SqlCommand query1 = new SqlCommand(t, con);
                // выполнить запрос
                query1.ExecuteNonQuery();
                con.Close();
                MessageBox.Show("Заказ сформирован.", "Внимание!",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();  // закрыть форму
            }
            catch
            {
                MessageBox.Show("Ошибка добавления нового заказа.", "Внимание!",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void FormAddOrder_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'svFabricDataSet.Clothess' table. You can move, or remove it, as needed.
            this.clothessTableAdapter.Fill(this.svFabricDataSet.Clothess);
            // TODO: This line of code loads data into the 'svFabricDataSet.Izdelie' table. You can move, or remove it, as needed.
            this.izdelieTableAdapter.Fill(this.svFabricDataSet.Izdelie);
            GetClothesFromDB();
            FillClothes();
            GetFurnituraFromDB();
            FillLVFurnitura();
        }
    }
}
